-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.2.4 Ereignisgesteuerte Simulation
--
-- Simulationsmodell einer 3-Gatter-Schaltung durch je
-- einen Prozess je Gatter und einen Prozess für die 
-- Bereitstellung der Testeingaben
---------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;


entity G3_Proc is end entity;


architecture Sim of G3_Proc is
 signal x1, x2, x3, x4, z1, z2, y: std_logic := '0';
begin

-- Prozess zur Simulation von Gatter G1
G1: process
 begin
  z1<=x1 and x2 after 1 ns;
  wait on x1, x2;
 end process;

-- Prozess zur Simulation von Gatter G2
G2: process
 begin
  z2<=x3 and x4 after 1 ns;
  wait on x3, x4;
 end process;

-- Prozess zur Simulation von Gatter G3
G3: process
 begin
  y<=z1 or z2 after 2 ns;
  wait on z1, z2;
 end process;

-- Prozess zur Erzeugung der Eingabesignale
Eingabe: process
 begin
  wait for 1 ns;  x3<='1';		-- 1 ns
  wait for 2 ns;  x1<='1'; x4<='1';	-- 3 ns
  wait for 2 ns;  x2<='1';		-- 5 ns
  wait for 3 ns;  x3<='0';		-- 8 ns
  wait for 2 ns;  x2<='0';		--10 ns
  wait for 1 ns;  x4<='0';		--11 ns
  wait for 2 ns;  x1<='0'; x4<='1';	--13 ns
  wait for 1 ns;  x2<='1'; x3<='1';	--14 ns
  wait for 2 ns;  x1<='1';		--16 ns
  wait for 1 ns;  x3<='0';		--17 ns
  wait for 2 ns;  x2<='0';		--19 ns
  wait for 2 ns;  x1<='0'; x4<='0';	--21 ns
  wait for 1 ns;  x3<='1';		--22 ns
  wait;
 end process;

end architecture;
