-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.2.5 Strukturbeschreibung
-- Datei: Oder2.vhdl
--
-- zwei Beschreibungsversionen für ein ODER2-Gatter
---------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity Oder2 is
 generic(td: delay_length);
 port(a, b: in std_logic; 
       c: out std_logic);
end entity;

architecture Vers1 of Oder2 is
begin
 c <= a or b after td;
end architecture;

architecture Vers2 of Oder2 is
 signal u, v: std_logic;
begin
 u <= a after td;
 v <= b after td;
 c <= u or v;
end architecture;
