-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.2.4 Ereignisgesteuerte Simulation
--
-- Prozess zur Simulation einer 5-Gatter-Schaltung
---------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

entity ProcSimG5 is end entity;

architecture a of ProcSimG5 is
 signal x: std_logic_vector(4 downto 0);
 signal y: std_logic_vector(1 downto 0);
 constant td: delay_length := 2 ns;
begin

Schaltungsprozess:process
  variable v: std_logic_vector(2 downto 0);
 begin
  v(0):= x(0) nand x(1);
  v(1):= x(2) nand x(3);
  v(2):= x(0) nand x(4);
  y(0) <= v(0) nand v(1) after td;
  y(1) <= v(1) nand v(2) after td;
  wait on x;
 end process;

Eingabe: process
  begin
   wait for 5 ns; x <= "10010";
   wait for 5 ns; x <= "10011";
   wait for 5 ns; x <= "00010";
  --  ...

  wait;
 end process;
end architecture;

