-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.2.5 Strukturbeschreibung
-- Datei: Und2.vhdl
--
-- zwei Beschreibungsversionen für ein UND2-Gatter
---------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity Und2 is
 generic(td: delay_length);
 port(a, b: in std_logic; 
       c: out std_logic);
end entity;

architecture Vers1 of Und2 is
begin
 c <= a and b after td;
end architecture;

architecture Vers2 of Und2 is
 signal u, v: std_logic;
begin
 u <= a after td;
 v <= b after td;
 c <= u and v;
end architecture;
