-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.3.1 Glitches
--
-- Kontrolle der Signalverläufe in Abb. 1.38
---------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;
entity SimGlitch2 is end entity;

architecture a of SimGlitch2 is
 signal x1, x2, z, y, zz, yy: std_logic;
 constant td1: delay_length:=4 ns;
 constant td2: delay_length:=3 ns;
begin
-- mit rekonvergenerter Auffächerung
 z <= x1 nand x2 after td1;
 y <= x1 nand z after td2;

-- ohne rekonvergente Auffächerung
 zz <= not x2 after 4 ns;
 yy <= x1 nand zz after 3 ns;


 x1 <= '0', '1' after 12 ns, '0' after 31 ns, '1' after 40 ns, '0' after 56 ns;
 x2 <= '0', '1' after  7 ns, '0' after 21 ns, '1' after 48 ns, '0' after 61 ns;
end architecture;
