-- P1.3/TestVM.vhdl
--
-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.3.2 Das Verzögerungsmodell einer Signalzuweisung
--
-- Ausprobieren der unterschiedlichen Verzögerungsmodelle
---------------------------------------------------------------


entity Test_VM is end entity;

architecture a of Test_VM is
 -- Signalvereinbarungen
 signal y1, y2, y3: natural;

begin

 process
  -- Variablenvereinbarungen

 begin
  -- zu_testende_Anweisungen
  y1 <= 1 after 1 ns, 2 after 2 ns, 3 after 3 ns, 4 after 4 ns, 5 after 5 ns;
  y2 <= 1 after 1 ns, 2 after 2 ns, 3 after 3 ns, 4 after 4 ns, 5 after 5 ns;
  y3 <= 1 after 1 ns, 2 after 2 ns, 3 after 3 ns, 4 after 4 ns, 5 after 5 ns;
  wait for 2.5 ns;
  -- zweite Zuweisung mit dem Standardverzögerungsmodell
  y1 <= 8 after 3 ns, 9 after 4 ns;
  -- zweite Zuweisung mit dem Transportverzögerungsmodell
  y2 <= transport 8 after 3 ns, 9 after 4 ns;
  -- zweite Zuweisung mit reject+inertial und einer Rückweiszeit von 2
  y3 <= reject 1.6 ns inertial 8 after 3 ns, 9 after 4 ns;
  wait for 1 ns;
  wait;
 end process;
end architecture;

