-- P1.5/Entprellung.vhdl

-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.5.2 Entprellen von Tasten
--
-- Entprellen und Flankenerkennung für eine Tasteneingabe
---------------------------------------------------------------



library ieee;
use ieee.std_logic_1164.all;

entity Entprellung is end entity;

architecture Test of Entprellung is
 signal T, x, x_del, x_del2, y: std_logic;
 constant th: delay_length:= 0.1 ns;
 constant td: delay_length:= 0.2 ns;

begin

 process(T)
 begin

  if rising_edge(T) then
   if x='1' then
    x_del<='1'; 
   else
    x_del<='0';
   end if;
   x_del2 <= x_del;
  end if;
 end process;
 
 y <= 'X' after th, not x_del and x_del2 after td;

 Taktprozess: process
 begin
  if now > 20 ns then wait; end if;
  wait for 0.54 ns; T<='1';
  wait for 0.54 ns; T<='0';
 end process;


-- Tastensignal
 x <= '1', 'X' after 0.7 ns, '0' after 0.8 ns, 'X' after  2.8 ns, '1' after 3.1 ns,
           'X' after 5.7 ns, '0' after 6.8 ns, 'X' after  8.8 ns, '1' after 9.1 ns,
           'X' after 10.2 ns, '0' after 11 ns, 'X' after 13.4 ns, '1' after 15.4 ns;
end architecture;
