-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.6.7 Zusammenfassung und Uebungsaufgaben

-- Aufgabe 1.23
-- Decoder zum Erkennen von Punkten und Strichen in einem 
-- Morse-Signal
---------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all; --fg

library Tuc;
use Tuc.Numeric_Sim.all;

entity Morse is
 port(T, nI, nx: in std_logic;
      p, s, err: out std_logic);
end entity;


architecture Verh of Morse is
 signal I_del, x_del: std_logic;
 signal z: std_logic_vector(1 downto 0);
 signal ct: tUnsigned(4 downto 0);
begin
 -- Eingabeabtastung
 process(T)
 begin
  if rising_edge(T) then
   I_del <= not nI;
   x_del <= not nx;
  end if;
 end process;

 -- Uebergangsfunktion
 process(I_del, T)
 begin
  if I_del='1' then
   z<="00";
  elsif rising_edge(T) then
   case z is
    when "00" =>               -- Zustand "Start"
     ct<="00000";
     if x_del='1' then z<="01"; end if;
    when "01" =>               -- Zustand Zählen
     if ct /= "11111" then ct <= ct + "1"; end if;
     if x_del='0' then z<="10"; end if;
    when others =>             -- Ausgabe
     z <= "00";
   end case;
  end if;
 end process;

 -- kombinatorische Aufgabefunktionen
 process(z, ct)
  variable vp, vs, verr: std_logic;
 begin
  vp:='0'; vs:='0'; verr:='0';
  if z="10" then
   case ct is
    when "00100"|"00101"|"00110" => vp:='1';
    when "01100"|"01101"|"01110"|"01111"|"10000"|"10001"|"10010" => vs:='1';
    when others => verr:='1';
   end case;
  end if;
  p<=vp; s<=vs; err<=verr;
 end process;
end architecture; 

