-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.6.7 Zusammenfassung und Uebungsaufgaben

-- Aufgabe 1.23
-- Testrahmen für den Morse-Decoder
---------------------------------------------------------------



library ieee;
use ieee.std_logic_1164.all;


entity Test_Morse is end entity;

architecture a of Test_Morse is
 signal T, nx, nI, p, s, err: std_logic;
begin

 -- Testobjekt
 TObj: entity work.Morse(Verh) port map(T=>T, nI=>nI, nx=>nx, p=>p, s=>s, err=>err);

 -- Taktgenerator:
 -- solange die geplante Simulationszeit nicht überschritten ist 
 -- (Abfrage der aktuellen Simulationszeit mit "now"), wird der Takt
 -- mit einer Verzögerung 25 ms (halbe Taktperiode), wenn er '1' ist,
 -- auf '0' und sonst auf '1' gesetzt
 process(T)
 begin
  if now < 1.8 sec then
   if T='1' then T <= '0' after 25 ms;
   else T<='1' after 25 ms;
   end if;
  end if;
 end process;

 -- Erzeugung des Initialisierungs- und des Eingabesignals 
 nI <= '0' after 10 ms, '1' after 83 ms;

 nx <= '1' after  34 ms,
       '0' after   167 ms,  '1' after   375 ms,  -- Punkt
       '0' after   511 ms,  '1' after 1.206 sec, -- Strich
       '0' after 1.427 sec, '1' after 1.532 sec; -- Fehler (zu kurz)

end architecture;
 
