-- P1.6/Test_QuadEnc.vhdl

-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.6.5 Operationsablaufgraph

-- Testrahmen für den Quadraturencoder
---------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Numeric_Sim.all;

entity Test_QuadEnc is end entity;

architecture Verh of Test_QuadEnc is
 signal T, I: std_logic; 
 signal ab: std_logic_vector(1 downto 0);
 signal ct: tSigned(15 downto 0);
begin

 TObj: entity work.QuadEnc(a) 
    port map (T=>T, I=>I, ab=>ab, ctout=>ct);


 -- Taktgenerator:
 -- solange die geplante Simulationszeit nicht überschritten ist 
 -- (Abfrage der aktuellen Simulationszeit mit "now"), wird der Takt
 -- mit einer Verzögerung um eine halbe Taktperiode, wenn er '1' ist,
 -- auf '0' und sonst auf '1' gesetzt
 process(T)
 begin
  if now < 20 ms then
   if T='1' then T <= '0' after 0.5 ms;
   else T<='1' after 0.5 ms;
   end if;
  end if;
 end process;

 I <= '1', '0' after 2.7 ms;

 ab <= "00" after  1.0 ms, "01" after  2.5 ms, 
       "11" after  3.6 ms, "10" after  4.9 ms, 
       "00" after  6.3 ms, "10" after  7.7 ms, 
       "11" after  8.9 ms, "10" after 10.2 ms, 
       "00" after 11.3 ms, "10" after 12.5 ms, 
       "11" after 13.7 ms, "01" after 15.0 ms, 
       "00" after 16.3 ms, "10" after 17.5 ms, 
       "11" after 18.7 ms, "01" after 19.0 ms; 

end architecture;
