-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.6.7 Zusammenfassung und Uebungsaufgaben

-- Aufgabe 1.22
-- Taktteilerprozess in einem Testrahmen
---------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

entity Test_Taktteiler is end entity;

architecture a of Test_Taktteiler is
 signal T, T2n: std_logic;
 constant n: positive:=2;
 signal ct: natural;
begin

Taktteilerprozess: process(T)
 begin
  if rising_edge(T) then
   if T2n='1' then
    if ct=n-1 then T2n<='0'; ct<=0;
    else ct<=ct+1;
    end if;
   else
    if ct=n-1 then T2n<='1'; ct<=0;
    else ct<=ct+1;
    end if;
   end if;
  end if;
 end process;

 -- Taktbereitstellung
 -- solange die geplante Simulationszeit nicht überschritten ist 
 -- (Abfrage der aktuellen Simulationszeit mit "now"), wird der Takt
 -- mit einer Verzögerung gleich der halben Taktperiode, wenn er '1' ist,
 -- auf '0' und sonst auf '1' gesetzt
 process(T)
 begin
  if now < 30 ns then
   if T='1' then T <= '0' after 1 ns;
   else T<='1' after 1 ns;
   end if;
  end if;
 end process;

end architecture;
