-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 1.6.4 Entwurf eines Zahlenschlosses
---------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

entity Zahlenschloss is end entity;

architecture Test of Zahlenschloss is

signal T, I, I_next, xu, xu_del, y: std_logic;
 signal s: std_logic_vector(2 downto 0);
 signal x, x_next: std_logic_vector(3 downto 0);
begin

 -- Beschreibung der Abtastregister
 process(T)
 begin
  if rising_edge(T) then
   x <= x_next;
   I <= I_next;
   xu_del <= xu;
  end if;
 end process;

 -- nebenläufige Bildung von xu
 xu <= x(0) and x(1) and x(2) and x(3);

 -- Abtastprozess der Uebergangsfunktion
 process(I, T)
  variable v: std_logic_vector(6 downto 0);
 begin
  if I='0' then
   s <= "000";
  elsif rising_edge(T) and xu='0' and xu_del ='1' and s(2)='0' then
   v := s & x;
   case v is
    when "000" & "1110" => s<="001"; 
    when "001" & "0111" => s<="010"; 
    when "010" & "1101" => s<="100"; 
    when others => s <= "111";
   end case;

  end if;
 end process;

 -- nebenläufige Anweisung zur Bildung von y
 y<=not s(2) or s(1) or s(0);

 Taktprozess: process
 begin
  if now > 40 ns then wait; end if;
  T<='1'; wait for 0.6 ns; 
  T<='0'; wait for 0.6 ns;
 end process;

 Eingabeprozess: process
 begin
  -- Anfangsinitialisierung
  I_next <= '1'; x_next<="1111"; wait for 2.1 ns;

  -- korrekte Eingabe
  I_next <= '0'; wait for 2.5 ns; I_next <= '1'; wait for 1.6 ns;
  x_next <= "1110"; wait for 4 ns; x_next<="1111"; wait for 2.1 ns;
  x_next <= "0111"; wait for 2.2 ns; x_next<="1111"; wait for 1.6 ns;
  x_next <= "1101"; wait for 1.7 ns; x_next<="1111"; wait for 3.1 ns;

  -- zurückzuweisende Eingabe
  I_next <= '0'; wait for 2.5 ns; I_next <= '1'; wait for 1.6 ns;
  x_next <= "1010"; wait for 4 ns; x_next<="1111"; wait for 1.1 ns;
  x_next <= "0111"; wait for 2.2 ns; x_next<="1111"; wait for 1.6 ns;

  wait; 
 end process;

end architecture;




