-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.1.4 Latches
--
-- Abtastprozess mit einer bedingten Variablenzuweisung,
-- die auch mit einem Latch nachgebildet werden kann 
-- (Abb. 2.24)
--------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

entity BedVarZuwLatch is
 port(T, a, b, c: in std_logic;
      y: out std_logic);
end entity;

architecture Synth of BedVarZuwLatch is
begin

 process(T)
  variable v: std_logic;
 begin
  if rising_edge(T) then
   if b='1' then
    v:= c;
   end if;
   y <= v xor a;
  end if;
 end process;
end architecture;
