-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.1.4 Latches

-- Simulationsmodell für ein Latch (Abb. 2.21)
--------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

entity Latch is 
 generic(th: delay_length:=0.1 ns;
         td: delay_length:=0.3 ns;
         ts: delay_length:=0.2 ns);
 port( E: in std_logic;
       x: std_logic_vector(3 downto 0);
       y: buffer std_logic_vector(3 downto 0));
end entity;

architecture Sim of Latch is
begin

 Latch: process(x, E)
  variable tE:delay_length;
 begin
  if  y/=x and E/='0' then y <= "XXXX"; end if;
  if E='1' then y <= transport x after td; end if;

  if rising_edge(E) then
   tE:=now;
  elsif falling_edge(E) and  (now-tE<ts or x'last_event<ts) then
   y <= "XXXX";
  end if;
 end process;

end architecture;



