-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.1.6 Entwurfsfehler und Fehlervermeidung
--
-- Unbeabsichtigtes Latch durch eine fehlende Zuweisung in 
-- einer Auswahlanweisung
--------------------------------------------------------



library ieee;
use ieee.std_logic_1164.all;

entity MuxCaseLatch is
 port( x1, x2, x3: in std_logic_vector(3 downto 0);
       s: in std_logic_vector(1 downto 0);
       y: out std_logic_vector(3 downto 0));
end entity;

architecture Synth of MuxCaseLatch is
begin

 process(s, x1, x2, x3)
 begin
  case s is
   when "00" =>  y <= x1;    
   when "01" =>  y <= x2; 
   when "10" =>  y <= x3; 
   when others => null;
   -- Korrektur:
   --when others => y <= x3;
  end case;
 end process;
end architecture;
