library ieee;
use ieee.std_logic_1164.all;

entity SynthBSL is
 port(E: in std_logic;
      a: in std_logic_vector(1 downto 0);
      x: in std_logic_vector(3 downto 0);
      y0, y1, y2, y3: out std_logic_vector(3 downto 0));
end entity;

architecture Synth of SynthBSL is
 signal s, q: std_logic_vector(3 downto 0);
begin

Dec:process(a)
 begin
  case a is
   when "00"   => s <= "0001";
   when "01"   => s <= "0010";
   when "10"   => s <= "0100";
   when others => s <= "1000";
  end case;
 end process;

Und:process(s, E)
 begin
  if E='1' then q <= s;
  else q <= "0000";
  end if;
 end process;

Latch0:process(x, q(0))
 begin
  if q(0)='1' then y0<=x; end if;
 end process;

Latch1:process(x, q(1))
 begin
  if q(1)='1' then y1<=x; end if;
 end process;

Latch2:process(x, q(2))
 begin
  if q(2)='1' then y2<=x; end if;
 end process;

Latch3:process(x, q(3))
 begin
  if q(3)='1' then y3<=x; end if;
 end process;
end architecture;
