-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.1.4 Latches
--
-- Testrahmen für Abtastprozess mit einer bedingten Variablenzuweisung,
-- die auch mit einem Latch nachgebildet werden kann (Abb. 2.24)
------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all; 

entity TestBedVarZuwLatch is end entity;

architecture Synth of TestBedVarZuwLatch is
signal T, a, b, c, y: std_logic;
begin
TObj: entity work.BedVarZuwLatch(Synth)
      port map (T=>T, a=>a, b=>b, c=>c, y=>y);

Testprozess: process
            
               begin
                 wait for 1 ns; T<='0'; a<='0'; c<='0'; 
                 while now<25 ns loop
                 wait for 1 ns; T<='1'; b<='1';
                 
                 wait for 1 ns; T<='0';
                 wait for 1 ns; T<='1'; b<='1';
                
                 wait for 1 ns; T<='0';
                 wait for 1 ns; T<='1'; b<='0';
                
                 wait for 1 ns; T<='0';
                 wait for 1 ns; T<='1'; b<='1';
                 wait for 1 ns; T<='0'; a<=not a;
                 end loop;
                 wait;
               end process;

-- Ausgabeprozess
process(T, y)
 begin
  write(rechts(str(NOW), 9) & ": T=" & str(T) & " y=" & str(y));
 end process;
end architecture;
