-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.1.4 Latches
--------------------------------------------------------
-- Testrahmen für die Beschreibung des Latch-Blockspeichers
-- aus Abb. 2.21

library ieee;
use ieee.std_logic_1164.all;

entity TestLatchBS is end entity;

architecture Test of TestLatchBS is
 signal E : std_logic;
 signal a : std_logic_vector(1 downto 0);
 signal x, y0_synth, y1_synth, y2_synth, y3_synth, 
        y0_sim, y1_sim, y2_sim, y3_sim: std_logic_vector(3 downto 0);
begin

 TObj_Synth:entity work.LatchBS(Synth) 
  port map(x=>x, a=>a, E=>E, y0=>y0_synth, y1=>y1_synth, y2=>y2_synth, y3=>y3_synth);

 TObj_Sim:entity work.LatchBS(Sim) 
  port map(x=>x, a=>a, E=>E, y0=>y0_sim, y1=>y1_sim, y2=>y2_sim, y3=>y3_sim);


Testprozess: process
 begin
  wait for 1 ns; x<="0000"; E <='0'; a<="00";
  wait for 1 ns; E <='1';
  wait for 1 ns; E <='0';
  wait for 1 ns; x<="0011"; a<="01";
  wait for 1 ns; E <='1';
  wait for 1 ns; E <='0';
  wait for 1 ns; x<="0110"; a<="10";
  wait for 1 ns; E <='1';
  wait for 1 ns; E <='0';
  wait for 1 ns; x<="1100"; a<="11";
  wait for 1 ns; E <='1';
  wait for 1 ns; E <='0';
  wait for 1 ns; x <="0100";
  wait for 1 ns; E <='1';

  wait;
 end process;
end architecture;

