-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.1.6 Entwurfsfehler und Fehlervermeidung
--
-- Testrahmen für Unbeabsichtigtes Latch durch eine 
-- fehlende Zuweisung in einer Auswahlanweisung
--------------------------------------------------------



library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;

entity TestMuxCaseLatch is end entity;

architecture Synth of TestMuxCaseLatch is
signal x1, x2, x3, y: std_logic_vector(3 downto 0);
signal s: std_logic_vector(1 downto 0);
begin
TObj: entity work.MuxCaseLatch(Synth)
      port map (x1=>x1, x2=>x2, x3=>x3, y=>y, s=>s);

Testprozess: process
               begin
                 wait for 1 ns; x1<="0000"; s<="00"; write(" y=" & str(y));
                
  		 wait for 1 ns; x2<="0011"; s<="01"; write(" y=" & str(y));
  		
  		 wait for 1 ns; x3<="0110"; s<="10"; write(" y=" & str(y));
  		
  		 wait for 1 ns;             s<="11"; write(" y=" & str(y)); --Ein Latch wird hier erzeugt
  		
  		 wait for 1 ns; x1<="0100"; s<="00"; write(" y=" & str(y));
                 wait for 1 ns;                      write(" y=" & str(y));
  		 wait;
 	       end process;
end architecture;
