-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.1.4 Latches
--
-- Simulation des Zeitverhaltens der Latch-Schaltung mit 
-- dem Vergleicher zur Bildung des Uebernahmesignals 
-- (Abb. 2.22)
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity VglLatch is end entity;

architecture Sim of VglLatch is
 signal x1, x2, y: std_logic_vector(3 downto 0);
 signal E: std_logic;
begin

Vergleicher: process(x1, x2)
  constant th: delay_length:= 120 ps;
  constant td: delay_length:= 250 ps;
 begin 
  E <= 'X' after th;
  if (not is_x(x1)) and (x1=x2) then
   E <= transport '1' after td;
  elsif not is_x(x1) and not is_x(x2) then
   E<= transport '0' after td;
  end if;
 end process;
  
Latch: entity work.Latch(Sim) port map(x=>x1, E=>E, y=>y);

Testprozess: process
 begin
  x1 <= "0111";  x2 <= "0100";
  wait for 2 ns; x1 <= "0110";
  wait for 2 ns; x2 <= "0110";
  wait for 2 ns; x1 <= "1110";
  wait for 2 ns; x1 <= "1010";
  wait;
 end process;
end architecture;
