-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.5.4 Hierarchischer Addierer
--
-- Package zum Test des hierarchischen Addierers in 
-- Abb. 2.87
--------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

package HiAdd_pack is


 type tPG is record
  p: std_logic;
  g: std_logic;
 end record;

 function OpPG(a, b: tPG) return tPG;

end package;

package body HiAdd_pack is

 function OpPG(a, b: tPG) return tPG is
  variable y: tPG;
 begin
  y.p:=b.p and a.p;
  y.g:=b.g or (a.g and b.p);
  return y;
 end function; 

end package body;
