-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.5.2 Serieller Addierer
--
-- Testrahmen für beide  Beschreibungsversionen des 
-- seriellen Addierers
--------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Numeric_Sim.all;
use Tuc.Ausgabe.all;
use Tuc.StopSim_pack.all;

entity Test_SerAdd is end entity;

architecture TB of Test_SerAdd is
 signal T, cin, cout1, cout2, Start, busy1, busy2: std_logic;
 signal x1, x2, y1, y2: std_logic_vector(3 downto 0);
begin

TestobjSim: entity work.SerAdd(Sim) port map (T=>T, cin=>cin, x1=>x1, x2=>x2, y=>y1, Start=>Start, busy_out=>busy1, cout=>cout1);

TestobjSynth: entity work.SerAdd(Synth) port map (T=>T, cin=>cin, x1=>x1, x2=>x2, y=>y2, Start=>Start, busy_out=>busy2, cout=>cout2);


TaktGen(T, 10 ns);

Testprozess: process
 begin
  x1<=x"A"; x2<=x"3"; cin<='0'; Start<='0'; wait until rising_edge(T); 
  Start<='1'; wait until rising_edge(T);
  Start<='0'; wait until rising_edge(T) and busy1='0';

  wait until rising_edge(T);
  x1<=x"8"; x2<=x"9"; cin<='1'; Start<='0'; wait until rising_edge(T);
  Start<='1'; wait until rising_edge(T);
  Start<='0'; wait until rising_edge(T) and busy1='0';
  StopSim;
  wait;
 end process;

end architecture;




