-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.6.5 Dividierer
--
-- Testrahmen für die Beschreibungen des seriellen 
-- Dividierers; zum Test der aublauforientierten 
-- Beschreibung ist der beschreibungsname "synth"
-- durch "sim" zu ersetzen
--------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Numeric_Sim.all;
use Tuc.Ausgabe.all;
use Tuc.StopSim_pack.all;

entity Test_SerDiv is end entity;

architecture TB of Test_SerDiv is
 signal T, Start, busy: std_logic;
 signal Divident, Divisor, Quotient, Rest: tUnsigned(3 downto 0);
begin

Testobj: entity work.SerDiv(Synth) 
port map (T=>T, Divident=>Divident, Divisor=>Divisor, Quotient=>Quotient,
  Rest_out=>Rest, busy_out=>busy, Start=>Start);

TaktGen(T, 10 ns);

Testprozess: process
 begin
  Divident<=x"A"; Divisor<=x"3"; Start<='0'; wait until rising_edge(T); 
  Start<='1'; wait until rising_edge(T);
  Start<='0'; wait until rising_edge(T) and busy='0';

  wait until rising_edge(T);
  Divident<=x"8"; Divisor<=x"5"; Start<='0'; wait until rising_edge(T);
  Start<='1'; wait until rising_edge(T);
  Start<='0'; wait until rising_edge(T) and busy='0';
  StopSim;
  wait;
 end process;

end architecture;




