-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Abschnitt 2.6.9 Zusammenfassung und Uebungsaufgaben
--
-- Testrahmen für die beiden Versionen eines Multiplizierers 
-- für vorzeichenbehaftete Zahlen
-- * Aufgabe 2.20 (Beschreibungsname StrucSVA)
-- * Aufgabe 2.22 (Beschreibungsname Mux)
--------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Numeric_Sim.all;
use Tuc.Ausgabe.all;
--use Tuc.StopSim_pack.all;

entity Test_SignedMult is end entity;

architecture TB of Test_SignedMult is
 signal a, b: tSigned(3 downto 0);
 signal y1, y2: tSigned(7 downto 0);
begin

MuxVers: entity work.SignedMult(Mux) 
 port map (a=>a, b=>b, y=>y1);
SVAVers: entity work.SignedMult(StrucSVA) 
 port map (a=>a, b=>b, y=>y2);


Testprozess: process
 begin
  a<="0011"; b<="1101"; wait for 10 ns;
  write("a=" & str(a) & " b=" & str(b) & " y1=" & str(y1) & " y2=" & str(y2));
  a<=x"A"; b<=x"3"; wait for 10 ns;
  write("a=" & str(a) & " b=" & str(b) & " y1=" & str(y1) & " y2=" & str(y2));
  a<=x"2"; b<=x"4"; wait for 10 ns;
  write("a=" & str(a) & " b=" & str(b) & " y1=" & str(y1) & " y2=" & str(y2)); 
  a<=x"F"; b<=x"5"; wait for 10 ns;
  write("a=" & str(a) & " b=" & str(b) & " y1=" & str(y1) & " y2=" & str(y2)); 
  a<=x"0"; b<=x"E"; wait for 10 ns;
  write("a=" & str(a) & " b=" & str(b) & " y1=" & str(y1) & " y2=" & str(y2)); 
  wait;
 end process;

end architecture;




