-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.1.9 Zusammenfassung und Uebungsaufgaben
--
-- Package zu den Aufgabenlösungen
---------------------------------------------------------------------

-- Vorspann
library ieee;
use ieee.std_logic_1164.all;
-- für die Funktion rand
use work.Rand_pack.rand;

library Tuc;
--use Tuc.Eingabe.all;
use Tuc.Ausgabe.all; 
use Tuc.Numeric_Sim.all;


package Lsg_pack is

-- Lösung zu Aufgabe 3.2
 function seg7(x: std_logic_vector(2 downto 0)) return std_logic_vector;

-- Lösung zu Aufgabe 3.3
function count1(x: std_logic_vector) return natural;

-- Lösung zu Aufgabe 3.4
 procedure TMG(signal T, I: out std_logic; 
      signal x: out tUnsigned(1 downto 0));

 procedure Akku(signal T, I: std_logic;
       signal x: tUnsigned(1 downto 0);
       signal y: inout tUnsigned(3 downto 0));
end package;


package body Lsg_pack is

-- Lösung zu Aufgabe 3.2
 function seg7(x: std_logic_vector(2 downto 0)) return std_logic_vector is
 begin
  case x is
   when "000"  => return "011111";
   when "001"  => return "110011";
   when "010"  => return "011110";
   when "011"  => return "110001";
  when others => return "000000";
  end case;
 end function;

-- Lösung zu Aufgabe 3.3
 function count1(x: std_logic_vector) return natural is
  variable i: natural:= 0; 
 begin
  for idx in x'range loop 
   if x(idx)='1' then
    i:=i+1;
   end if;
  end loop; 
  return i; 
 end function;


-- Lösung zu Aufgabe 3.3
 procedure TMG(signal T, I: out std_logic; 
      signal x: out tUnsigned(1 downto 0)) is 
 begin
  I<='1'; T<='0'; x<="00"; wait for 2 ns;
  I<='0'; wait for 1 ns; 
  for idx in 1 to 10 loop
   T <= '1'; wait for 1 ns;
   if rand<0.5 then x(0) <= '0'; else x(0) <= '1'; end if;
   if rand<0.5 then x(1) <= '0'; else x(1) <= '1'; end if;
   T<='0'; wait for 1 ns;
 end loop;
 end procedure;

 procedure Akku(signal T, I: std_logic;
       signal x: tUnsigned(1 downto 0);
       signal y: inout tUnsigned(3 downto 0)) is
 begin
  if I='1' then
   y <= "0000";
  elsif rising_edge(T) then
   y <= x + y;
  end if; 
 end procedure;

end package body;
