-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.1.5 Unreine Funktionen und globale Variablen
--
-- Package mit der "unreinen" Funktion rand zur Bereistellung von 
-- Zufallszahlen
---------------------------------------------------------------------

-- Vorspann
library ieee;
use ieee.std_logic_1164.all;
-- für die Funktion rand
use ieee.math_real; 

library Tuc;
use Tuc.Eingabe.all;
use Tuc.Ausgabe.all; 
use Tuc.Numeric_Sim.all;

package Rand_pack is
--======================================================================== 

 -- unreine Funktion zur Bereistellung von Zufallszahlen aus Abschn. 3.1.5
 shared variable seed1, seed2: positive;
 impure function rand return real;

--======================================================================== 
end package;


package body Rand_pack is
--======================================================================== 

---------------------------------------------------------------------------
 -- unreine Funktion zur Bereistellung von Zufallszahlen aus Abschn. 3.1.5
 impure function rand return real is  
   variable y: real; 
  begin  
   ieee.math_real.uniform(seed1, seed2, y);
   return y;
  end function; 

----------------------------------------------------------------------------

--======================================================================== 
end package body;
