-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.1.8 Nebenläufige Prozeduraufrufe
--
-- Beschreibung des Testobjekts, der Testeingabebereitstellung und der 
-- der Protokollierung der Testergebnisse durch nebenläufige Prozeduren
-- * nand_proc(...) Nachbildung eines NAND2-Gatters
-- * Testgen(...)   Nachbildung eines Testmustergeneratorprozesses
-- * Ausgabe(...)   Nachbildung des Testausgabeprozesses
---------------------------------------------------------------------

-- Vorspann
library ieee;
use ieee.std_logic_1164.all;
library Tuc;
--use Tuc.Eingabe.all; 
use Tuc.Ausgabe.all; 
--use Tuc.Numeric_Sim.all;

-- Package mit dem zu testenden Unterprogramm
use work.UP_pack.all;

entity TestNLProz is end entity;

architecture a of TestNLProz is
 -- Signalvereinbarungen
 signal x: std_logic_vector(1 downto 0);
 signal y: std_logic;
begin
 Testgen(x, 2 ns);
 nand_proc(x(0), x(1), y, 0.25 ns, 0.5 ns);
 Ausgabe(x, y);

end architecture;
