-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.1.7 Prozeduren
--
-- Package mit einer Prozedur mit Ein- und Ausgabesignalen
---------------------------------------------------------------------

-- Vorspann
library ieee;
use ieee.std_logic_1164.all;
-- für die Funktion rand
use ieee.math_real; 

library Tuc;
use Tuc.Eingabe.all;
use Tuc.Ausgabe.all; 
use Tuc.Numeric_Sim.all;

package W5T_pack is
--======================================================================== 

 -- Prozedur mit Ein- und Ausgabesignal aus Abschn. 3.1.7
 procedure W5T(signal T: std_logic; signal y: out std_logic);

--======================================================================== 
end package;


package body W5T_pack is
--======================================================================== 
----------------------------------------------------------------------------
 -- Prozedur mit Ein- und Ausgabesignal aus Abschn. 3.1.7
 procedure W5T(signal T: std_logic; signal y: out std_logic) is
 begin
  wait until RISING_EDGE(T);
  y<='1';
  for idx in 1 to 5 loop
   wait until RISING_EDGE(T);
  end loop;
  y<='0';
 end procedure;


--======================================================================== 
end package body;
