-- Package zu Abschn. 3.1
--
-- 01.03.2010, G. Kemnitz
---------------------------------------------------------------------

-- Vorspann
library ieee;
use ieee.std_logic_1164.all;
-- für die Funktion rand
use ieee.math_real; 

library Tuc;
use Tuc.Eingabe.all;
use Tuc.Ausgabe.all; 
use Tuc.Numeric_Sim.all;

package countx_pack is
--======================================================================== 
 -- Funktionsbeschreibung einer kombinatorischen Schaltung
 function fWTab(x: std_logic_vector(2 downto 0)) return std_logic_vector;

-- Uebergangsfunktion eines Spezialzählers zur Erzeugung aller Variationen 
-- von Testeingaben einschliesslich der mit einem einzelnen ungültigen Bit
 function countx(x: std_logic_vector) return std_logic_vector;

--======================================================================== 
end package;


package body countx_pack is
--======================================================================== 
 -- Funktionsbeschreibung einer kombinatorischen Schaltung
 function fWTab(x: std_logic_vector(2 downto 0)) return std_logic_vector is
  variable y: std_logic_vector(2 downto 0);
 begin
  case x is
   when "000"             => y:="100";
   when "001"|"011"|"110" => y:="110";
   when "010"|"101"       => y:="101";
   when "100"             => y:="001";
   when "111"             => y:="011";
   when others            => y:="XXX";
  end case;
  return y;
 end function;

---------------------------------------------------------------------------
 -- Uebergangsfunktion eines Spezialzählers zur Erzeugung von Testeingaben,
 -- die auch en eizelnes ungültiges Bit enthalten können

 function countx(x: std_logic_vector) return std_logic_vector is
  variable y: std_logic_vector(x'range):=x;
 begin
  for idx in x'low to x'high loop
   --write("y'low=" & str(y'low) & " y'high=" & str(y'high))
   if y(idx) = '0' then y(idx):='1'; exit;
   elsif y(idx)='1' and  not is_X(y(y'high downto idx+1)) then 
    y(idx):='X'; exit;
   else y(idx):='0'; 
   end if;
  end loop;
  return y;
 end function;


--======================================================================== 
end package body;
