-- Absch. 3.2.9 Verbund/Gleitkommaformat
-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.2.10 Zusammenfassung und Uebungsaufgaben
--
-- Aufgabe 3.9 
-- Die Typen und die zu testenden Funktionen sind hier ausnahmsweise 
-- nicht in einem Package, sondern im Vereinbarungsteil der 
-- Entwurfseinheit vereinbart.
---------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Numeric_Sim.all;
use Tuc.Ausgabe.all;

entity Afg_tZustand3SG is end entity;

architecture Test of Afg_tZustand3SG is

 type tZustand3SG is record
  s: std_logic;
  y: tUnsigned(3 downto 0);
 end record;

 procedure Init(signal x: out tZustand3SG) is
 begin
  x <= (s => '0', y => "0000");
 end procedure;

 procedure Count(signal x: inout tZustand3SG) is
 begin
  if    x.s='0' then x.y <= x.y + "1";
  elsif x.s='1' then x.y <= x.y - "1";
  end if;
 end procedure;

 function str(x: tZustand3SG) return string is
 begin
  return "(s=" & str(x.s) & ", y=" & str(x.y) & ")";
 end function;

 signal x: tZustand3SG;

begin

 process
 begin
  Init(x); wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  Count(x); x.s <= '1'; wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  Count(x); x.s <= '0'; wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  Count(x); wait for 1 ns; write("x =" & str(x));
  wait;
 end process;
end architecture;



  

