-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.2.5 Felder
--
-- Testrahmen zu Beispiel 3.5 (Feldattribute)
---------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;

library Tuc;
use Tuc.Ausgabe.all;

entity Test_Feld is end entity;

architecture a of Test_Feld is
begin

 process
  subtype tIdx1 is integer range 1 to 5; 
  subtype tIdx2 is integer range 7 downto 4;
  type tFeld2D is array (tIdx1, tIdx2) of std_logic; 

  type tZustand is (S1, S2, S3, S4);
  type tByte is array (7 downto 0) of std_logic;
  type tZustandTab is array (tZustand) of tByte;

  variable Feld2D: tFeld2D;
  variable idx1: tIdx1;
  variable idx2: tIdx2;
  variable x, y: std_logic;

  -- zu Beispiel 3.5: vordefinierte Feldattribute
  type tTab is array (1 to 5, 6 downto 4) of natural;
  variable Tab: tTab;

 begin
  y:=Feld2D(idx1, idx2);          
  Feld2D(idx1, idx2):=x;          

  -- zu Beispiel 3.5: vordefinierte Feldattribute
  write("Tab'left(1)=" & str(Tab'left(1)));
  write("Tab'ascending(2)=" & str(Tab'ascending(2)));
  for idx in Tab'reverse_range(2) loop
   write("idx=" & str(idx));
  end loop;
  wait;
 end process;

end architecture;
