-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.2.8 Adressierbare Speicher
--
-- Test eines RAM-Modells
-- Der Testprozess testet erst einen Schreib- dann einen Lesezugriff
--
-- 07.03.2010, G. Kemnitz  
--
library IEEE;
use IEEE.STD_LOGIC_1164.all;

library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Eingabe.all;
use Tuc.Numeric_Sim.all;

entity Test_RAM is end entity;

architecture a of Test_RAM is
 subtype tDaten is std_logic_vector(3 downto 0);
 type tSpeicher is array (natural range <>) of tDaten;
 signal Speicher: tSpeicher(1 to 3) := (1=>x"5", 2=>x"7", 3=>x"a");
 signal adr:  tUnsigned(1 downto 0);
 signal x, y: tDaten;
 constant th: DELAY_LENGTH:= 1 ns;
 constant td: DELAY_LENGTH:= 3 ns;
begin
 process
  variable v_adr: tUnsigned(1 downto 0);
  variable v_x: tDaten;
 begin
  loop
  -- Testeingaben für den Lesezugriff
   read("2-Bit-Adresse eingeben:", v_adr);
   adr <= v_adr; wait for 10 ns;
   -- Verhaltensmodell des Lesezugriffs
   if is_x(adr) or int(adr)<Speicher'low or int(adr)>Speicher'high then
    y <= (others=>'X');
   else
    y <= (others=>'X') after th, Speicher(int(adr)) after td;
   end if;
   wait for 10 ns;
   -- Ausgabe des gelesenen Wertes
   write("adr=" & str(adr) & " gelesener Wert: " &str(y));

  -- Testeingaben für den Schreibzugriff
   read("4-Bit-Daten eingeben:", v_x);
   x <= v_x; wait for 100 ns;
   -- Verhaltensmodell des Schreibzugriffs
   if is_x(adr) then
    for idx in Speicher'RANGE loop
     Speicher(idx) <= (others=>'X');
    end loop;
   elsif int(adr)>=Speicher'low and int(adr)<=Speicher'high then
    Speicher(int(adr))<=x;
   end if;
   wait for 10 ns;
   -- Anzeige des Speicherzustands nach dem Schreibzugriff
   write("Speicherinhalt: " & str(Speicher(1)) & ' ' & str(Speicher(2)) 
        & ' ' & str(Speicher(3)));
  end loop;
  wait;
 end process;
end architecture;

