-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.4.7 Zusammenfassung und Uebungsaufgaben
--
-- Package zur Lösung von Aufgabe 3.14
---------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Eingabe.all;
use Tuc.Ausgabe.all;
use Tuc.Numeric_Sim.all;

package AfgCount1_pack is

 function Anzahl1a(x: std_logic_vector; N: natural) return tUnsigned;
 function Anzahl1b(x: std_logic_vector; N: natural) return tUnsigned;

end package;

package body AfgCount1_pack is

 function Anzahl1a(x: std_logic_vector; N: natural) return tUnsigned is
  variable sum: tUnsigned(N-1 downto 0):=(others=>'0');
 begin
  for idx in x'range loop
   if x(idx)='1' then sum := sum + "1"; end if;
  end loop;
  return sum;
 end function;

 function Anzahl1b(x: std_logic_vector; N: natural) return tUnsigned is
  type tVektortyp is array (natural range <>) of tUnsigned(N-1 downto 0);
  constant xl: natural := x'length;
  variable z: tVektortyp(2*xl-2 downto 0);
  variable idx2: natural;
 begin
  for idx in x'range loop
   --write("idx=" & str(idx) & " idx2=" & str(idx2));
   if x(idx)='1' then z(idx2):=(0=>'1', others=>'0');
   else z(idx2):=(others=>'0'); end if; idx2 := idx2+1;
  end loop;

--write("----- z'low=" & str(z'low) & " z'high=" & str(z'high));

  for idx in 0 to xl-2 loop
   --write("idx+xl=" & str(idx+xl) & " 2*idx=" & str(2*idx) & " 2*idx+1=" & str(2*idx+1));

   z(idx+xl):=z(2*idx) + z(2*idx+1);
  end loop;
  return z(z'high);
 end function;

end package body;
