-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.4.3 Register und Latches als nebenläufige Prozeduren
--
-- Testrahmen für die Prozedur zur Nachbildung der Funktion eines Latches
---------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.all;

library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Eingabe.all;
use Tuc.Numeric_Sim.all;

use work.Latch_pack.all;

entity Test_Latch is end entity;

architecture a of Test_Latch is
 signal E1: std_logic;
 signal a, b: std_logic_vector(3 downto 0);
begin

-- Verhaltensmodell des Registers
 LatchModell(E => E1, x => a, y => b, td => 1.5 ns, th => 0.5 ns, ts => 1 ns);

-- Testprozess
 process
 begin
  wait for 2 ns; E1<='1'; a<="0001"; wait for 2 ns; 
  E1<='0'; wait for 1 ns; a <="1100"; wait for 1 ns;
  E1<='1'; wait for 0.5 ns; E1<='0'; wait for 2 ns;

  wait;
 end process;
end architecture;
