-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.4.4 Adressierbare Schreib-Lese-Speicher
--
-- Testrahmen für die Kernfunktion eines RAMs
---------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Eingabe.all;
use Tuc.Numeric_Sim.all;

use work.RAM_pack.all;


entity Test_RAM is end entity;

architecture test of Test_RAM is
 signal Adr: tUnsigned(0 to 7);
 signal di, do: std_logic_vector(3 downto 0);
 signal W: std_logic;
begin

 ram(w=>W, a=>Adr, x=>di, y=>do, thy=> 2 ns, tdy=> 5 ns, tsa=> 2 ns,
      tna=> 0 ns, twr=> 7 ns, tsx=> 4 ns);

Testprozess: process
 begin
  W <='0'; wait for 5 ns;
  Adr <= x"00"; di <= x"2"; wait for 3 ns;
  W <= '1'; wait for 10 ns; W <= '0'; wait for 3 ns;
  Adr <= x"01"; di <= x"7"; wait for 3 ns;
  W <= '1'; wait for 10 ns; W <= '0'; wait for 3 ns;
  Adr <= x"00"; wait for 10 ns;
  Adr <= x"01"; wait for 10 ns;
  Adr <= x"02"; wait for 10 ns;
  wait;
 end process;
end architecture;

