-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.4.3 Register und Latches als nebenläufige Prozeduren
--
-- Testrahmen für die Prozedur zur Nachbildung der Funktion eines Registers
---------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;

library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Eingabe.all;
use Tuc.Numeric_Sim.all;

use work.Reg_pack.all;

entity Test_Reg is end entity;

architecture a of Test_Reg is
 signal T1, I1, E1: std_logic;
 signal a, b: std_logic_vector(3 downto 0);
begin

-- Verhaltensmodell des Registers
 RegModell(T => T1, I => I1, E => E1, x => a, y => b, aw => "0011", 
    td => 1.5 ns, th => 0.5 ns, ts => 1 ns);

-- Testprozess
 process
 begin
  wait for 2 ns; I1<='1'; T1<='0'; wait for 5 ns; I1<='0'; wait for 1 ns;
  a<="1110"; wait for 1 ns; E1<='1'; wait for 2 ns; T1<='1'; wait for 2 ns;
  T1 <='0'; wait for 0.2 ns; a<="0110"; wait for 1.5 ns; T1<='1'; wait for 2 ns;
  T1 <='0';
  wait;
 end process;
end architecture;
