-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.4.6 Schrittweise Modellentwicklung -- Beispiel UART
--
-- Test der der ablauforientierten UART-Beschreibung
---------------------------------------------------------------------

  
library IEEE;
use IEEE.STD_LOGIC_1164.all;

library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Eingabe.all;
--use Tuc.Numeric_Sim.all;

use work.UART1_pack.all;

entity Test_UART1 is end entity;

architecture a of Test_UART1 is
 signal x, y: tByte;
 signal Start, Busy, TxD, RxD, Ready, Err: std_logic;
 constant tbit: delay_length:= 10 ns;
begin

 Sender(Start=>Start, x=>x, TxD=>TxD, Busy=>Busy, tbit=>tbit);
 Empfaenger(RxD=>RxD, y=>y, Ready=>Ready, Err=>Err, tbit=>0.99*tbit);

 RxD <= transport TxD after 5 ns; 

 Eingabe: process
 begin
  Start <= '0' after 2 ns, '1' after 20 ns, '0' after 30 ns;
  x <= XX after 15 ns, x"3f" after 18 ns; wait until falling_edge(Busy);
  Start <= '1' after 28 ns, '0' after 73 ns;
  x <= XX after 7 ns, x"79" after 9 ns; wait until falling_edge(Busy);
  wait;
 end process;

 Ausgabe: postponed process(Start, x, Busy, TxD, RxD, y, Ready, Err)
  variable TabKopf: boolean:=true;
 begin
  if TabKopf then
   write("  Zeit   |Start|    x   |Busy|TxD|RxD|    y   |Ready|Err");
   TabKopf:=false;
  end if;
  write(rechts(str(now),9) & "|  " & str(Start) & "  |" & str(x) & "|  " & str(Busy) &
    " | " & str(TxD) & " | " &  str(RxD) & " |" &  str(y) & "|  " & str(Ready) & "  | " &
    str(Err));
 end process;

end architecture;
