-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.4.7 Entwicklung eines CORDIC-Rechenwerks
--
-- Testrahmen fuer den ersten Entwurf eines CORDIC-Rechenwerkes
---------------------------------------------------------------------



library ieee;
use ieee.math_real.cos;
use ieee.math_real.sin;

library Tuc;
use Tuc.Eingabe.all;
use Tuc.Ausgabe.all;
use work.cordic1_pack.all;

entity cordic1 is end entity;
architecture a of cordic1 is
 signal x, y, phi: tDaten;
 constant tp: delay_length:= 1 ns;
begin
 process
  variable phi_Ziel: tDaten;--, sin_soll, cos_soll: tDaten;
  constant cAtanTab: tDatenArray:=fAtanTab(16);
  constant SCS: tDaten:=fSCS(cAtanTab);
 begin
  --wait for tP; 
  --write("");
  read(">>" & str(now)&": Winkel im Bereich -pi/4 bis pi/4 eingeben (Abruch mit Exit)", phi_Ziel, -2.0, 2.0);
  x<=1.0; y<=0.0; phi<=0.0;
  wait for tP; 
  for idx in cAtanTab'range loop
   if phi_Ziel>phi then
    x<=x-(y sra idx);  
    y<=y+(x sra idx);
    phi<=phi + cAtanTab(idx);
   else
    x<=x+(y sra idx);  
    y<=y-(x sra idx);
    phi<=phi - cAtanTab(idx);
   end if;
   wait for tP; 

  end loop;
  x<=SCS*x; y<=SCS*y; 
  wait for tP; 

  write("Ergebnis:   phi="&str(phi, 6)&" cos="&str(x, 6)&" sin="&str(y, 6));
  write("Soll-Werte: phi="&str(phi_Ziel, 6)& " cos="& str(cos(phi_Ziel), 6)& " sin="&str(sin(phi_Ziel), 6));
  write("Differenz: phi="&str(phi_Ziel-phi, 6)& " cos="& str(cos(phi_Ziel)-x, 6)& " sin="&str(sin(phi_Ziel)-y, 6));
 end process;
end architecture;
