-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.4.7 Entwicklung eines CORDIC-Rechenwerks
--
-- CORDIC-Rechenwerk mit Festkommazahlen und seqentieller Multiplikation
---------------------------------------------------------------------

library ieee;
use ieee.math_real.cos;
use ieee.math_real.sin;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Eingabe.all;
use Tuc.Ausgabe.all;
use Tuc.Numeric_Sim.all;
use work.cordic2_pack.all;

entity cordic3 is end entity;
architecture a of cordic3 is
 signal x, y, px, py, phi: tDaten;
 constant tp: delay_length:= 1 ns;
begin
 process
  variable phi_z_real: real;
  variable phi_Ziel: tDaten;
  constant cAtanTab: tDatenArray:=fAtanTab(16);
  constant cSCS: tDaten:=fSCS(cAtanTab);
 begin
  wait for tP; 
  write("");
  read(">> Winkel im Bereich -pi/4 bis pi/4 eingeben (Abruch mit Exit)", phi_z_real, -2.0, 2.0);
  phi_Ziel:=to_tDat(phi_z_real);
  x<=to_tDat(1.0); y<=to_tDat(0.0); phi<=to_tDat(0.0);
  wait for tP; 
  for idx in cAtanTab'range loop
   if phi_Ziel>phi then
    x<=x-(y sra idx);  
    y<=y+(x sra idx);
    phi<=phi + cAtanTab(idx);
   else
    x<=x+(y sra idx);  
    y<=y-(x sra idx);
    phi<=phi - cAtanTab(idx);
   end if;
   wait for tP; 
  end loop;
 -- Multiplikation  
  px<=x sra 1;
  py<=y sra 1;
  wait for tP; 
  for idx in 12 downto 0 loop
   if cSCS(idx)='1' then
    px <= px + (x sra (14-idx));
    py <= py + (y sra (14-idx));
   end if;
   wait for tP; 
  end loop; 
 
  wait for tP; 
  write("Ergebnis:   phi="&str_real(phi)&" cos="&str_real(px) & " sin="&str_real(py));
  write("Soll-Werte: phi="&str(phi_z_real, 4)& " cos="& str(cos(phi_z_real), 4)& " sin="&str(sin(phi_z_real), 4));
 end process;
end architecture;
