-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.5.4 Zusammenfassung und Uebungsaufgaben
--
-- Package mit einer Prozedur zur Erzeugung eines 
-- sinusförmigen Testeingabesignals
----------------------------------------------------------------



library ieee;
use ieee.std_logic_1164.all; -- importiert std_logic
use ieee.math_real.all;   -- importiert: sin, math_pi

library Tuc;
use Tuc.Numeric_Sim.all; 
use Tuc.Ausgabe.all;

package GenSin_pack is

 procedure GenSin(signal T: std_logic; signal y: out tSigned; 
   A: natural; tpsim: delay_length; phi: real);

end package;

package body GenSin_pack is

 procedure GenSin(signal T: std_logic; signal y: out tSigned; 
   A: natural; tpsim: delay_length; phi: real) is
  variable r: real;
 begin
  assert A < 2 ** (y'length-1) report "A ist zu gross" severity error;
  if rising_edge(T) then
   r := 2.0*math_pi*real(now/ps)/real(tPsim/ps)+phi;
   y<=to_tSigned(integer(real(A)*sin(r)), y'length);
  end if;

 end procedure;

end package body;

