-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.5.1 Pseudo-Zufallstest und Mehrversionsvergleich
--
-- Testrahmen für einen Pseudo-Zufallstest und 
-- Mehrversionsvergleich des 7-Segment-Decoders
-- aus Abschnitt 2.2
----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;

use work.MVTest_pack.all;

entity MVTestSeg7 is end entity;

architecture a of MVTestSeg7 is
 signal T: std_logic;
 signal x: std_logic_vector(3 downto 0);
 signal y_ist, y_soll: std_logic_vector(6 downto 0);
begin

 Version_FU: entity work.Seg7Dec(FU) port map(x, y_soll); 
 Version_KV: entity work.Seg7Dec(KV) port map(x, y_ist); 

 Taktgenerator:        TaktGen(T, 10 ns, 1000 ns);
 Testeingabegenerator: RTPG(T, x, (0 to 3=>0.2));
 Testauswertung:       Vergleicher(T, x, y_ist, y_soll, 1 ns);

end architecture;

