-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 3.5.3 Spezifikationstest
--
-- Testrahmen für den Spezifikationstest-Prozedur
----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;

use work.SpecTest_pack.all;

entity Test_SpecTest is end entity;

architecture a of Test_SpecTest is
 signal Taste: std_logic;
 signal y, y_gf: tAusgabe;
 constant t_glitch:delay_length:= 10 ms; -- Maximaldauer ungültiger Ausgaben
 constant ta:      delay_length:= 2 min; -- Mindestdauer Autos grün
 constant tF:      delay_length:= 2 min; -- Richtwert der Dauer Fussgänger grün
 constant tmin:    delay_length:= 30 sec;-- Mindestdauer der anderen Ampelphasen
 constant tmax:    delay_length:= 45 sec;-- Maximaldauer der anderen Ampelphasen
 constant twa_max: delay_length:= 4 min; -- max. Wartezeit dr Autos auf grün
 constant twf_max: delay_length:= 3 min; -- max. Wartezeit der Fussgänger auf grün
 
begin

 y_gf <= y after t_glitch;
 SpecTest_Ampel(y_gf, Taste, ta, tF, tmin, tmax, twa_max, twf_max);

 Testprozess: process
  begin
-- die auskommentierten Zeilen enthalten Fehler, die der Spec-Test erkennen muss
-- noch unvollständig 

   write(" 1"); y <= Start; Taste <= '0'; wait for 0.5*tmin;        -- zulässig
   -- Zeitueberschreibung Startphase
   --write(" 1"); y <= Start; Taste <= '0'; wait for 1.1*tmax; 	    
   write(" 2"); y <= "XXXXX", ge_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 
   -- unzulässiger Folgewert
   --write(" 2"); y <= "XXXXX", rt_rt  after 2 ms; wait for 1.1*tmin;  
   write(" 3"); y <= "XXXXX", gn_rt  after 2 ms; wait for 1.1*ta;   -- zulässig 
   -- Maximaldaue für ungültige Ausgaben überschritten 
   --write(" 3"); y <= "XXXXX", gn_rt  after 1.2*t_glitch; wait for 1.1*ta; 
   write(" 4"); y <= "XXXXX", ge_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 
   write(" 5"); y <= "XXXXX", rt_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 
   write(" 6"); y <= "XXXXX", rt_gn  after 2 ms; wait for tF; 	    -- zulässig 
   -- zu lange Grünphase für Fussgänger
   --write(" 6"); y <= "XXXXX", rt_gn  after 2 ms; wait for 1.3*tF;
   write(" 7"); y <= "XXXXX", rt_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 
   write(" T"); Taste <= '1', '0' after 2 sec;
   write(" 8"); y <= "XXXXX", ge_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 
   write(" 9"); y <= "XXXXX", gn_rt  after 2 ms; wait for 1.7*ta;   -- zulässig 
   write("10"); y <= "XXXXX", ge_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 
   write("11"); y <= "XXXXX", rt_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 
   write("12"); y <= "XXXXX", rt_gn  after 2 ms; wait for tF;       -- zulässig 
   write("13"); y <= "XXXXX", rt_rt  after 2 ms; wait for 1.1*tmin; -- zulässig 

  wait;
 end process;
end architecture;

