-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 4.1.3 Signale mit mehreren Quellen und der Typ std_logic
--
-- Modellierung des Ausgangs eines NOR-Gatters als Signal 
-- mit zwei Quellen
----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity NOR2nq is
 generic(tdn0, tdnZ, tdnX, 
         tdp1, tdpZ, tdpX: delay_length);
 port(x1, x2: std_logic;
      y:  out std_logic);
end entity;

architecture sim of NOR2nq is
 signal yn, yp: std_logic;
begin

 process(x1, x2)
 begin
  if (x1 or x2)='1' then
   yn <= '0' after tdn0;
   yp <= 'Z' after tdpZ;
  elsif (x1 or x2)='0' then
   yn <= 'Z' after tdnZ;
   yp <= '1' after tdp1;
  else
   yn <= 'X' after tdnX;
   yp <= 'X' after tdpX;
  end if;
 end process;

 y <= yn;
 y <= yp;
 
end architecture;
