-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 4.1.3 Signale mit mehreren Quellen und der Typ std_logic
--
-- Testrahmen für das NOR-Gatter, dessen Ausgang als Signal 
-- mit zwei Quellen modelliert ist
----------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;

entity Test_NOR2nq is end entity;

architecture test of Test_NOR2nq is
 signal x1, x2, y: std_logic;
begin

Testobj: entity work.NOR2nq(Sim)
  generic map(tdn0=> 50 ps, tdnZ=> 80 ps, tdnX=> 40 ps, 
              tdp1=>100 ps, tdpZ=>120 ps, tdpX=> 80 ps)
  port map(x1=>x1, x2=>x2, y=>y);

Testprozess: process
 begin
  wait for 100 ps; x1<='0';
  wait for 100 ps; x2<='0';
  wait for 100 ps; x1<='1';
  wait for 100 ps; x1<='0';
  wait for 100 ps; x2<='1';
  wait for 100 ps; x1<='1';
  wait;
 end process;

Protokollprozess: process(y)
 begin
  write(rechts(str(now), 10) & " y=" & str(y));
 end process;

end architecture;
  
  
