-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 4.2.5 Simulation mit geschalteten Transistorbreiten
--
-- Testrahmen für das Simulationsmodell eines Komplexgatters 
-- mit geschalteten Transistorbreiten
----------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;


entity Test_KG10T is end entity;

architecture Sim of Test_KG10T is
 signal  x: std_logic_vector(5 downto 1);
 signal y: std_logic;
begin

 TObj: entity work.KG10T(Sim) port map(x1=>x(1), x2=>x(2), x3=>x(3), 
     x4=>x(4), x5=>x(5), y=>y);

 process
  constant tp: delay_length:=1 ns;
 begin
  
  wait for tp; x <= "00000"; write(rechts(str(now), 8) & "Einschalten alle Transistoren");
  wait for tp; x <= "01011"; write(rechts(str(now), 8) & "Ausschalten über x1, x2, x4");
  wait for tp; x <= "01010"; write(rechts(str(now), 8) & "Einschalten über x1 und x3");
  wait for tp; x <= "11011"; write(rechts(str(now), 8) & "Ausschalten über x1, x2, x4, x5");
  wait for tp; x <= "01000"; write(rechts(str(now), 8) & "Einschalten über x1, x2, x3");
  wait for tp; x <= "10100"; write(rechts(str(now), 8) & "Ausschalten über x3, x5");
  wait for tp; x <= "00X0X"; write(rechts(str(now), 8) & "Einschalten über (x1), (x3), x4, x5");
  wait for tp; x <= "01X11"; write(rechts(str(now), 8) & "Ausschalten über x1, x2, (x3), x4");
  wait for tp; x <= "01X10"; write(rechts(str(now), 8) & "Einschalten über x1, (x2), x3");
  wait for tp; x <= "1101X"; write(rechts(str(now), 8) & "Ausschalten über (x1), x2, x4, x5");

  wait;
 end process;

end architecture;
  
