-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 4.4.3 Assoziativspeicher
--
-- Testrahmen mit Simulationsmodell für einen  Assoziativspeicher
---------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Numeric_Sim.all;

use work.AsRAM_pack.all;

entity Test_AsRAM is end entity;

architecture a of Test_AsRAM is
 signal Mem: tMem(2 to 14);
 signal x: tDaten:=x"01";
 signal adr: tAdr:=x"0";
 signal hit: std_logic;
begin

 process
 begin
  for idx in 0 to 3 loop
   loop
    adr <= adr +"1";
    x <= x(6 downto 0) & (x(7) xor x(1));
    wait for 10 ns;
    write("adr=" & str(adr, 'h') & " Lesewert: " & str(read(Mem, adr)) &
      " Schreibwert: " & str(x));
    write(Mem, adr, x);
    if adr=x"0" then exit; end if;
   end loop;
  end loop;
  
  search(x=>x"08", adr=>adr, hit=>hit, Mem=>Mem); wait for 10 ns;
  write("Suchwert 08 hit=" & str(hit) & " adr=" & str(adr));
  search(x=>x"48", adr=>adr, hit=>hit, Mem=>Mem); wait for 10 ns;
  write("Suchwert 48 hit=" & str(hit) & " adr=" & str(adr));
  search(x=>x"a0", adr=>adr, hit=>hit, Mem=>Mem); wait for 10 ns;
  write("Suchwert a0 hit=" & str(hit) & " adr=" & str(adr));
  
  wait;
 end process;

end architecture;

