-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 4.4.1 SRAM
--
-- Testrahmen für das Simulationsmodell für einen asynchronen 
-- SRAM-Schaltkreis
---------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Eingabe.all;
use Tuc.Numeric_Sim.all;


entity Test_IS61 is end entity;

architecture test of Test_IS61 is
 signal adr: tUnsigned(7 downto 0);
 signal dat: std_logic_vector(15 downto 0);
 signal n_oe, n_cs, n_wr: std_logic;
begin

 TestObj: entity work.IS61(Sim) port map(adr=>adr, dat=>dat,
         n_oe=>n_oe, n_cs=>n_cs, n_wr=>n_wr);

Testprozess: process
 begin
  n_oe<='1'; n_cs<='0'; n_wr<='1'; wait for 6 ns;
  adr <= x"00"; dat <= x"EF12"; wait for 3 ns;
  n_wr <= '0'; wait for 12 ns;
  n_wr <= '1'; wait for  2 ns;
  dat <= (others => 'Z'); wait for 6 ns;
  adr <= x"01"; wait for  2 ns;
  n_oe<='0'; wait for  12 ns;
  adr <= x"00"; wait for  12 ns;
  n_oe<='1';
  wait;
 end process;
end architecture;

