-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 5.4 Entwurf eines RISC-Prozessors
--
-- Testrahmen für die Funktion des Rechenwerks mit Zufallsmustern
----------------------------------------------------------------

library ieee;
--use std.textio.all;
use ieee.STD_LOGIC_1164.all;
library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Zufallstest.all;
use Tuc.Eingabe.all;

use work.RISC_pack.all;
use work.RISC_Str_pack.all;

entity Test_ALU is end entity;

architecture a of Test_ALU is
begin
 process
  variable a, b: tDaten;
  variable opc: tOpcode;
  variable Ergebnis: tErgebnis;
  variable F: tFlags;
 begin
  shared_variable_RandStat:=(1235, 34567);
  loop
   write(str_RandStat); -- Anzeige des Zustands des Pseudo-Zufallsgenerators
   for idx in 1 to 10 loop
    a:=rand(a, 0.003);
    b:=rand(b, 0.003);
    opc:=rand(opc, 0.003); 
    F.cy:=rand(0.3, 0.003);
    Ergebnis:=ALU(a, b, F, opc);
    write(rechts(str_Opcode(opc),4) & ' ' & str_hex(a) & ", " & str_hex(b) & " cy:" & str(F.cy) & " => " & str(Ergebnis));
   end loop;
   read;
  end loop;
 end process;
end architecture;

