-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- 5.4 Entwurf eines RISC-Prozessors
--
-- Testrahmen für die Funktion des RISC-Prozessors
----------------------------------------------------------------



library ieee;
--use std.textio.all;
use ieee.STD_LOGIC_1164.all;
library Tuc;
use Tuc.Ausgabe.all;
use work.RISC_pack.all;
use work.RISC_Str_pack.all;

entity Test_RISC is end entity;

architecture a of Test_RISC is
 constant tp: DELAY_LENGTH:=10 ns;
 signal pp: tPipeline;
 signal RegSet: tDatMem(0 to 7);
 constant InstrMem: tInstrMem(0 to 30):=(
   0=> '1'& x"23" & "000",            -- init r0,23
   1=> '1'& x"34" & "001",            -- init r1,34
   2=> '1'& x"45" & "010",            -- init r2,45
   3=> '1'& x"56" & "011",            -- init r3,56
   4=> '1'& x"67" & "100",            -- init r4,67
   5=> '1'& x"78" & "101",            -- init r5,78
   6=> '1'& x"89" & "110",            -- init r6,89
   7=> '1'& x"a0" & "111",            -- init r7,a0
   8=> x"002",                        -- clr_cy
   9=> "01" & "0000" & "000" & "001", -- add r1,r0
  10=> "01" & "0010" & "011" & "010", -- sub r2,r3
  11=> "01" & "0010" & "001" & "001", -- sub r1,r1
  14=> "01" & "0001" & "001" & "010", -- inc r2,r1
  17=> "0010" & "00" & "010" & "000", -- st r0,@(r2+0)
  18=> "0010" & "01" & "010" & "001", -- st r1,@(r2+1)
  19=> "0010" & "10" & "010" & "010", -- st r2,@(r2+2)
  20=> "0010" & "11" & "010" & "011", -- st r3,@(r2+3)
  21=> "000011" & "010" & "011",      -- jmp r2,r3
  others => x"000");

 signal DatMem: tDatMem(0 to 30)  := (6=> x"26", others=>x"00");
 constant KonstMem: tDatMem(0 to 30):= (0=> x"1a", others=>x"00");

begin
 process
 begin

  write(str_array(InstrMem));
  write(" ");
  write(cProcStatTxt);
  pp.PCount<= x"00";
  wait for tp;
  for idx in 0 to 26 loop
   PipeStep(pp, InstrMem, RegSet, DatMem, KonstMem);
   write(str(pp, RegSet));
   wait for tp;
  end loop;
  write(" ");
  write(str_array(DatMem));
  wait;
 end process;
end architecture;

