----------------------------------------------------------------
-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Bibliothek Tuc
----------------------------------------------------------------
-- Package Tuc.StopSim
--
-- Prozeduren für den Abruch einer
-- Simulation mit mehreren Prozessen
----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

library Tuc;
use Tuc.Ausgabe.write; 


package StopSim_pack is
 shared variable StopSimulation: boolean;
 procedure StopSim(msg: string:="");
 procedure CheckStopSim(msg: string:="");
 procedure TaktGen(signal T: out std_logic; tP: delay_length);
end package;

package body StopSim_pack is
--=================================================
 procedure StopSim(msg: string:="") is
 begin
  if msg'length>0 then write(msg); end if;
  StopSimulation:=true;
  wait;
 end procedure;

 procedure CheckStopSim(msg: string:="") is
 begin
  if StopSimulation then 
   if msg'length>0 then write(msg); end if;
   wait; end if;
 end procedure;

-- Prozedur zur Simulation eines Taktgenerators
 procedure TaktGen(signal T: out std_logic; tP: delay_length) is
  variable TT: std_logic:='1';
 begin
  loop
   wait for tP/2;
   TT := not TT;
   if not StopSimulation then 
    T <= TT;
   else wait;
   end if;
  end loop;
 end procedure;


end package body;
