----------------------------------------------------------------
-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Bibliothek Tuc
----------------------------------------------------------------
-- Testrahmen fuer das Package Tuc.Ausgabe
--
-- 15.01.2010, G. Kemnitz
----------------------------------------------------------------


library ieee;
--use std.textio;
use ieee.std_logic_1164.all;
library Tuc;
use Tuc.Ausgabe.all;

entity Test_Ausgabe is
end entity;

architecture a of Test_Ausgabe is
begin
 process
  variable a, b: tString;
  variable tsa: tStringArray(0 to 3);
  constant SymbTab: STRING:= "load store add sub mult div ";
 begin

-------------------------------------------------
 if False then
  write(LF&"Test der Funktionen zum Zusammensetzen von Textzeilen"&LF);
  assign(a, str(30) & " Stunden");
  write("assign(a, str(30) & ' Stunden') : a = " &str(a));
  append(a, " Fahrzeit");
  write("append(a, ' Fahrzeit')          : a = " &str(a));
 end if;

 if False then
  write(LF&"Erzeugung mehzeiliger Texte mit einem String-Array"&LF);
  assign(tsa(0), "Text der 1. Zeile");
  append(tsa(0), " + angehaengter Text");
  assign(tsa(1), "Text der 2. Zeile");
  assign(tsa(2), "Zeile 3: extra Ausgabe");
  write(tsa(0 to 1));
  write(tsa(2));
 end if;



 if False then
  write(LF&"Test der str-Funktionen fuer Bit- und Bitvektor-Typen"&LF);
  write("str(BIT'('1')):                      " & str(BIT'('1')));
  write("str(True):                           " & str(True));
  write("str(STD_LOGIC'('U'), 't'):           " & str(STD_LOGIC'('U'), 't'));
  write("str(STD_LOGIC'('U')):                " & str(STD_LOGIC'('U')));
  write("str(STD_LOGIC'('0')):                " & str(STD_LOGIC'('0')));
  write("str(BIT_VECTOR'('11100101110'), 't'):" & str(BIT_VECTOR'("11100101110"), 't'));
  write("str(BIT_VECTOR'('11100101110'), 'o'):" & str(BIT_VECTOR'("11100101110"), 'o'));
  write("str(BIT_VECTOR'('11100101110'), 'h'):" & str(BIT_VECTOR'("11100101110"), 'h'));
  write("str(BIT_VECTOR'('11100101110'), 'd'):" & str(BIT_VECTOR'("11100101110"), 'd'));
  write("str(BIT_VECTOR'('11100101110'), 's'):" & str(BIT_VECTOR'("11100101110"), 's'));
  write("str(STD_LOGIC_VECTOR'(x'10a'), 't'): " & str(STD_LOGIC_VECTOR'(x"10a"), 't'));
  write("str(STD_LOGIC_VECTOR'(x'10a'), 'b'): " & str(STD_LOGIC_VECTOR'(x"10a"), 'b'));
  write("str(STD_LOGIC_VECTOR'(x'10a'), 'o'): " & str(STD_LOGIC_VECTOR'(x"10a"), 'o'));
  write("str(STD_LOGIC_VECTOR'(x'10a'), 'h'): " & str(STD_LOGIC_VECTOR'(x"10a"), 'h'));
  write("str(STD_LOGIC_VECTOR'(x'10a'), 'd'): " & str(STD_LOGIC_VECTOR'(x"10a"), 'd'));
  write("str(STD_LOGIC_VECTOR'(x'10a'), 's'): " & str(STD_LOGIC_VECTOR'(x"10a"), 's'));
  write("str(STD_LOGIC_VECTOR'('1UXZ0HL-W'), 't'): " & str(STD_LOGIC_VECTOR'("1UXZ0HL-W"), 't'));
  write("str(STD_LOGIC_VECTOR'('1UXZ0HL-W'), 'd'): " & str(STD_LOGIC_VECTOR'("1UXZ0HL-W"), 'd'));
 end if;

 if True then
  write("str_hex(STD_LOGIC_VECTOR'('11001110')): " & str_hex(STD_LOGIC_VECTOR'("11001110")));
  write("str_hex(STD_LOGIC_VECTOR'('11X01110')): " & str_hex(STD_LOGIC_VECTOR'("11X01110")));   
 end if;


 if False then
  write(LF&"Test der str-Funktionen fuer Zahlen- und Zeit-Typen"&LF);

  write("str(2.987, 't'):                     " & str(2.987, 't'));
  write("str(2.987, '1'):                     " & str(2.987, '1'));
  write("str(2.987, '2'):                     " & str(2.987, '2'));
  write("str(2.987, '3'):                     " & str(2.987, '3'));
  write("str(2.987, '4'):                     " & str(2.987, '4'));
  write("str(-2.987):                         " & str(-2.987));
  write("str(-2.987, 3):                      " & str(-2.987, 3));
  write("str(-0.0987, 5):                     " & str(-0.0987, 5));
  write("str(1345.99876, 'e'):                " & str(1345.99876, 'e'));
  write("str(0.056789)):                      " & str(0.056789));
  write("str(207654290.987):                  " & str(207654290.987));
  write("str(-57619)):                        " & str(-57619));
  write("str(35, 't'):                        " & str(35, 't'));
  write("str(35, 'h'):                        " & str(35, 'h'));
  write("str(35, 'o'):                        " & str(35, 'o'));
  write("str(35, 'b'):                        " & str(35, 'b'));
  write("str(35):                             " & str(35));
  write("str(integer'low):                    " & str(integer'low));
  write("str(DELAY_LENGTH'(1 ns), 't'):       " & str(DELAY_LENGTH'(1 ns), 't'));
  write("str(DELAY_LENGTH'(25 min)):          " & str(DELAY_LENGTH'(25 min)));
  write("str(DELAY_LENGTH'(12345 ps)):        " & str(DELAY_LENGTH'(12345 ps)));
  write("str(DELAY_LENGTH'(1981 ns)):         " & str(DELAY_LENGTH'(1981 ns)));
 end if;

 if False then
  write(LF&"Textausgabe mit Symboltabelle (SymTab: "&SymbTab&")"&LF);
  write("str(3, SymbTab):                     " & str(3, SymbTab));
  write("str(STD_LOGIC_VECTOR'(U11), SymbTab):" & str(STD_LOGIC_VECTOR'("U11"), SymbTab));
  write("str(STD_LOGIC_VECTOR'(101), SymbTab):" & str(STD_LOGIC_VECTOR'("101"), SymbTab));
 end if;
 ------------------------
 if False then
  write(LF&"Ausprobieren der Namensattribute:"&LF);
  write("STD_LOGIC'PATH_NAME:     "& STD_LOGIC'PATH_NAME);
  write("a'INSTANCE_NAME: "& a'INSTANCE_NAME);
 end if;

 wait;
 end process;
end architecture;
