----------------------------------------------------------------
-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Bibliothek Tuc
----------------------------------------------------------------
-- Testrahmen fuer das Package Tuc.Eingabe
--
-- 15.01.2010, G. Kemnitz
----------------------------------------------------------------

library ieee;
use std.textio;
use ieee.std_logic_1164.all;
library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Eingabe.all;

entity Test_Eingabe is
end entity;

architecture a of Test_Eingabe is
begin
 process
  variable x: tPString;
  variable pos: natural;
  variable r: real; 
  variable i: integer;
  variable t: time;
  variable bt: bit;
  variable bl: boolean;
  variable sl: std_logic;
  variable bv: bit_vector(3 downto 0);
  variable slv: std_logic_vector(1 downto 0);
  file f: textio.text open read_mode is "Testeingabe.txt"; 
 begin

  if True then
   loop
    read(f, x);
    write(str(x));
    exit when textio.endfile(f);
   end loop;
  end if;

  if False then
   clear(x); write(str(x));
   append(x, "Das "); write(str(x));
   append(x, "ist "); write(str(x));
   while x.Status=ok loop
    append(x, "xxxxxxxxxxxxx "); write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "Test das");
   --write("pta.pte: "&str(x.pta)&'.'&str(x.pte));
   --append(x, " nochmal");
   while x.pte>x.pta and x.Status=ok loop
   --write(str(x));
   get_char(x, pos, "asedfTgth "); 
   write(str(x.pta-1)&". Zeichen hat Position "&str(pos)&" in 'asedfTgth'");
   write("Restinhalt von x: "&str(x));
   end loop;
  end if;

  if False then
   assign(x, "Stunden ps ps; min; Stunden;");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    get_sym(x, pos, " ns; ps; min;Stunden;", ';'); 
    write("Symbolposition "&str(pos)&" in 'ns; ps; min; Stunden;'");
    write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "  Stunden   ps; min; Stunden;");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ;");
    write("Ohne fuehrende Leerzeichen und ';':" &str(x));
    get_sym(x, pos, " ns; ps; min;Stunden;", ';'); 
    write("Symbolposition "&str(pos)&" in 'ns; ps; min; Stunden;'");
    write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "  12423, 98745, +22,  -568");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, i); 
    write("Zahlenwert: " & str(i));
    write(str(x));
   end loop;
  end if;


  if False then
   assign(x, "  a12423.124, -0.045, +22,  ");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, R); 
    write("Zahlenwert: " & str(R, 4));
    write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "  23 ps, 17.7 fs, 83 min 23 hr,  ");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, t); 
    write("Zahlenwert: " & str(t));
    write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "  01, 02  ");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, bt); 
    write("Zahlenwert: " & str(bt));
    write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "  false, true  ");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, bl); 
    write("Zahlenwert: " & str(bl));
    write(str(x));
   end loop;
  end if;


  if False then
   assign(x, " X U, 0, W9b 01, 02  ");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, sl); 
    write("Zahlenwert: " & str(sl));
    write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "  01101110, 10001, 1X0  ");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, bv); 
    write("Zahlenwert: " & str(bv));
    write(str(x));
   end loop;
  end if;

  if False then
   assign(x, "  011U11X0, 10 U001, 1X0  ");
   write(str(x));
   while x.pte>x.pta and x.Status=ok loop
    skip(x, " ,");
    write("Ohne fuehrende Leerzeichen und Komma: " &str(x));
    get(x, slv); 
    write("Zahlenwert: " & str(slv));
    write(str(x));
   end loop;
  end if;

  if False then
   read("Bitte Zeichenkette eingeben:", x);
   write("Eingabe war: "&str(x));
  end if;
 
  if True then
   read("Bitte Integer zwischen -10 und 10 eingeben:", i, -10, 10);
   write("Eingabe war: "&str(i));
  end if;

  if False then
   read("Bitte Gleitkommazahl zwischen -12.0 und 10.0 eingeben:", R, -12.0, 10.0);
   write("Eingabe war: "&str(R));
  end if;

  if True then
   read("Bitte Bitwert eingeben:", bt);
   write("Eingabe war: "&str(bt));
  end if;


  if False then
   read("Bitte Boolean-Wert eingeben:", bl);
   write("Eingabe war: "&str(bl));
  end if;


  if False then
   read("Bitte Std_logic-Wert eingeben:", sl);
   write("Eingabe war: "&str(sl));
  end if;


  if False then
   read("Bitte 4-Bit-Vektor eingeben:", bv);
   write("Eingabe war: "&str(bv));
  end if;


  if False then
   read("Bitte std_logic_vector (2 Bit) eingeben:", slv);
   write("Eingabe war: "&str(slv));
  end if;


  --write(str(x));
  wait;
 end process;
end architecture;
