----------------------------------------------------------------
-- G. Kemnitz: Technische Informatik 
-- Band 2: Entwurf digitaler Schaltungen
-- Bibliothek Tuc
----------------------------------------------------------------
-- Testrahmen für das Package Tuc.Numeric_Synth
--
-- 18.02.2010, G. Kemnitz 
----------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.all;
library Tuc;
use Tuc.Ausgabe.all;
use Tuc.Numeric_Synth.all;

entity Test_Numeric_Synth is end entity;

architecture a of Test_Numeric_Synth is
begin

 process
  variable a, b: tUnsigned(7 downto 0);
  variable r, s: tSigned(7 downto 0);
  variable n: NATURAL;
  variable i: INTEGER;
 begin
 a:=x"53"; b:=x"27"; n:=2;
 r:=x"E5"; s:=x"14"; i:=-2;

 if true then
  write("Test (tUnsigned) mit a=" & str(a, 'h') & " b=" & str(b, 'h'));
  write("int(a):  " & str(int(a)));
  write("to_tUnsigned(n, 8):  " & str(to_tUnsigned(n, 8)));
 ----------------------------------
  write(LF&"Arithmetische Operationen für vorzeichenfreie Zahlen");
  write(str(a,'d') & "  +  " & str(b,'d') & " : " & str(a+b, 'd')     & " (" & str(a+b) & ")");
  write(str(a,'d') & "  -  " & str(b,'d') & " : " & str(a-b, 'd')     & " (" & str(a-b) & ")");
  write(str(a,'d') & "  *  " & str(b,'d') & " : " & str(a*b, 'd')     & " (" & str(a*b) & ")");
  write(str(a,'d') & "  /  " & str(b,'d') & " : " & str(a/b, 'd')     & " (" & str(a/b) & ")");
  write(str(a,'d') & " rem " & str(b,'d') & " : " & str(a rem b, 'd') & " (" & str(a rem b) & ")");
  write(str(a,'d') & " mod " & str(b,'d') & " : " & str(a mod b, 'd') & " (" & str(a mod b) & ")");

  write(LF&"Arithmetische Operationen für vorzeichenbehaftete Zahlen");
  write(str(r,'d') & "  +  " & str(s,'d') & " : " & str(r+s, 'd')     & " (" & str(r+s) & ")");
  write(str(r,'d') & "  -  " & str(s,'d') & " : " & str(r-s, 'd')     & " (" & str(r-s) & ")");
  write(str(r,'d') & "  *  " & str(s,'d') & " : " & str(r*s, 'd')     & " (" & str(r*s) & ")");
  write(str(r,'d') & "  /  " & str(s,'d') & " : " & str(r/s, 'd')     & " (" & str(r/s) & ")");
  write(str(r,'d') & " rem " & str(s,'d') & " : " & str(r rem s, 'd') & " (" & str(r rem s) & ")");
  write(str(r,'d') & " mod " & str(s,'d') & " : " & str(r mod s, 'd') & " (" & str(r mod s) & ")");

 ----------------------------------
  write(LF&"Vergleichsoperatoren für vorzeichenfreie Zahlen");
  write(str(a,'d') & " = "   & str(b,'d') & " : " & str(a=b));
  write(str(a,'d') & "/= "   & str(b,'d') & " : " & str(a/=b));
  write(str(a,'d') & " > "   & str(b,'d') & " : " & str(a>b));
  write(str(a,'d') & " < "   & str(b,'d') & " : " & str(a<b));
  write(str(a,'d') & ">= "   & str(b,'d') & " : " & str(a>=b));
  write(str(a,'d') & "<= "   & str(b,'d') & " : " & str(a<=b));

  write(LF&"Vergleichsoperatoren für vorzeichenbehaftete Zahlen");
  write(str(r,'d') & " = "   & str(s,'d') & " : " & str(r=s));
  write(str(r,'d') & "/= "   & str(s,'d') & " : " & str(r/=s));
  write(str(r,'d') & " > "   & str(s,'d') & " : " & str(r>s));
  write(str(r,'d') & " < "   & str(s,'d') & " : " & str(r<s));
  write(str(r,'d') & ">= "   & str(s,'d') & " : " & str(r>=s));
  write(str(r,'d') & "<= "   & str(s,'d') & " : " & str(r<=s));

 ----------------------------------
  write(LF&"Schiebe- und Rotationsbefehle für vorzeichenfreie Zahlen");
  write(str(a) & " sll " & str(n) & " : " & str(a sll n));
  write(str(a) & " srl " & str(n) & " : " & str(a srl n));
  write(str(a) & " rol " & str(n) & " : " & str(a rol n));
  write(str(a) & " ror " & str(n) & " : " & str(a ror n));

  write(LF&"Schiebe- und Rotationsbefehle für vorzeichenbehaftete Zahlen");
  write(str(r) & " sll " & str(n) & " : " & str(r sll n));
  write(str(r) & " srl " & str(n) & " : " & str(r srl n));
  write(str(r) & " rol " & str(n) & " : " & str(r rol n));
  write(str(r) & " ror " & str(n) & " : " & str(r ror n));
  write(str(r) & " sla " & str(n) & " : " & str(r sla n));
  write(str(r) & " sra " & str(n) & " : " & str(r sra n));
 ----------------------------------
  write(LF&"logische Operatoren für vorzeichenfreie Zahlen");
  write( "          not "   & str(a) & " : " & str(   not a));
  write(str(a) & "  and "   & str(b) & " : " & str(a  and b));
  write(str(a) & " nand "   & str(b) & " : " & str(a nand b));
  write(str(a) & "   or "   & str(b) & " : " & str(a   or b));
  write(str(a) & "  nor "   & str(b) & " : " & str(a  nor b));
  write(str(a) & "  xor "   & str(b) & " : " & str(a  xor b));
  write(str(a) & " xnor "   & str(b) & " : " & str(a xnor b));
 end if;

  wait;
 end process;
end architecture;
